local L = AceLibrary("AceLocale-2.2"):new("TrackingBar")
local inCombat = false

L:RegisterTranslations("enUS", function() return {
	["TrackingBar"] = true,
	["Config"] = true,
	["Set Config"] = true,
	["Scale"] = true,
	["Set Scale"] = true,
	["Alpha"] = true,
	["Set Alpha"] = true,
	["Button"] = true,
	["Select button displayed"] = true,
	["Show %s button"] = true,
	["Bar Config"] = true,
	["Set Bar Appearnce"] = true,
	["Direct"] = true,
	["Set Direct"] = true,
	["Vertical"] = true,
	["Horizontal"] = true,
	["Order"] = true,
	["Set Order"] = true,
	["Normal"] = true,
	["Reverse"] = true,
	["Show"] = true,
	["Config %s Button"] = true,
	["Adjust button order"] = true,
	["Binding"] = true,
	["Set %s button binding key"] = true,
	["Help"] = true,
	["To move bar, Ctrl+Right Drag button\nTo change button order, use button show function."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["TrackingBar"] = "추적바",
	["Config"] = "설정",
	["Set Config"] = "설정을 변경합니다",
	["Scale"] = "크기",
	["Set Scale"] = "크기를 조절합니다",
	["Alpha"] = "투명도",
	["Set Alpha"] = "투명도를 조절합니다",
	["Button"] = "버튼",
	["Select button displayed"] = "버튼의 표시 여부를 선택합니다",
	["Show %s button"] = "%s 버튼을 표시합니다",
	["Bar Config"] = "바 설정",
	["Set Bar Appearnce"] = "바의 외양을 설정합니다",
	["Direct"] = "방향",
	["Set Direct"] = "바의 방향을 설정합니다",
	["Vertical"] = "수직",
	["Horizontal"] = "수평",
	["Order"] = "순서",
	["Set Order"] = "버튼의 배열 순서를 설정합니다",
	["Normal"] = "정상",
	["Reverse"] = "역순",
	["Show"] = "표시",
	["Config %s Button"] = "%s 버튼에 대한 설정을 변경합니다",
	["Adjust button order"] = "버튼의 순서를 조정합니다",
	["Binding"] = "단축키",
	["Set %s button binding key"] = "%s 버튼에 대한 단축키를 설정합니다",
	["Help"] = "도움말",
	["To move bar, Ctrl+Right Drag button\nTo change button order, use button show function."] = "바를 이동하기 위해서는 버튼을 Ctrl 우클릭으로 드래그 하세요.\n버튼 순서를 조정하기 위해서는 버튼 표시 기능을 활용하세요.",
} end)

local BS = AceLibrary("Babble-Spell-2.2")
TrackingBar = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0");

local TrackingBarOptionTable = {
	name = L["TrackingBar"],
	desc = L["TrackingBar"],
	type = "group",
	args = {
		Help = {
			name = L["Help"],
			desc = L["Help"],
			type = 'execute',
			func = function()
				TrackingBar:Print(L["To move bar, Ctrl+Right Drag button\nTo change button order, use button show function."])
			end,
		},
		Config = {
			name = L["Config"],
			desc = L["Set Config"],
			type = "group",
			args = {
				Scale = {
					name = L["Scale"],
					desc = L["Set Scale"],
					type = "range",
					min = 0.1,
					max = 2.5,
					step = 0.1,
					get = function() return TrackingBar.db.profile.Scale end,
					set = function(v)
						TrackingBar.db.profile.Scale = v
						TrackingBar:SetUp()
						TrackingBarFrame:Show();
					end,
				},
				Alpha = {
					name = L["Alpha"],
					desc = L["Set Alpha"],
					type = "range",
					min = 0.0,
					max = 1.0,
					step = 0.05,
					get = function() return TrackingBar.db.profile.Alpha end,
					set = function(v)
						TrackingBar.db.profile.Alpha = v
						TrackingBar:SetUp()
						TrackingBarFrame:Show();
					end,
				},
				Bar = {
					name = L["Bar Config"],
					desc = L["Set Bar Appearnce"],
					type = "group",
					args = {
						Direct = {
							name = L["Direct"],
							desc = L["Set Direct"],
							type = "text",
							get = function() return TrackingBar.db.profile.Direct end,
							set = function(v) 
								TrackingBar.db.profile.Direct = v
								TrackingBar:SetUp()
								TrackingBarFrame:Show();
							end,
							validate = {["Vertical"] = L["Vertical"], ["Horizontal"] = L["Horizontal"]}
						},
						Order = {
							name = L["Order"],
							desc = L["Set Order"],
							type = "text",
							get = function() return TrackingBar.db.profile.Reverse end,
							set = function(v) 
								TrackingBar.db.profile.Reverse = v
								TrackingBar:SetUp()
								TrackingBarFrame:Show();
							end,
							validate = {["Normal"] = L["Normal"], ["Reverse"] = L["Reverse"]}
						},
					},
				},
				Button = {
					name = L["Button"],
					desc = L["Select button displayed"],
					type = 'group',
					args = {
						Beasts = {
							name = BS["Track Beasts"],
							desc = (L["Config %s Button"]):format( BS["Track Beasts"]),
							order = 1,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Beasts"]),
									disabled = function() return InCombatLockdown() end,
									type = 'toggle',
									get = function() return TrackingBar.db.profile.Beasts.Show end,
									set = function()
										TrackingBar.db.profile.Beasts.Show = not TrackingBar.db.profile.Beasts.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Beasts.Show, BS["Track Beasts"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Beasts"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Beasts"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Beasts"], v)
									end,
								},
							},
						},
						Demons = {
							name = BS["Track Demons"],
							desc = (L["Config %s Button"]):format( BS["Track Demons"]),
							order = 2,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Demons"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Demons.Show end,
									set = function()
										TrackingBar.db.profile.Demons.Show = not TrackingBar.db.profile.Demons.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Demons.Show, BS["Track Demons"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Demons"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Demons"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Demons"], v)
									end,
								},
							},
						},
						Dragonkin = {
							name = BS["Track Dragonkin"],
							desc = (L["Config %s Button"]):format( BS["Track Dragonkin"]),
							order = 3,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Dragonkin"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Dragonkin.Show end,
									set = function()
										TrackingBar.db.profile.Dragonkin.Show = not TrackingBar.db.profile.Dragonkin.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Dragonkin.Show, BS["Track Dragonkin"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Dragonkin"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Dragonkin"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Dragonkin"], v)
									end,
								},
							},
						},
						Elementals = {
							name = BS["Track Elementals"],
							desc = (L["Config %s Button"]):format( BS["Track Elementals"]),
							order = 4,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Elementals"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Elementals.Show end,
									set = function()
										TrackingBar.db.profile.Elementals.Show = not TrackingBar.db.profile.Elementals.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Elementals.Show, BS["Track Elementals"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Elementals"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Elementals"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Elementals"], v)
									end,
								},
							},
						},
						Giants = {
							name = BS["Track Giants"],
							desc = (L["Config %s Button"]):format( BS["Track Giants"]),
							order = 5,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Giants"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Giants.Show end,
									set = function()
										TrackingBar.db.profile.Giants.Show = not TrackingBar.db.profile.Giants.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Giants.Show, BS["Track Giants"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Giants"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Giants"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Giants"], v)
									end,
								},
							},
						},
						Hidden = {
							name = BS["Track Hidden"],
							desc = (L["Config %s Button"]):format( BS["Track Hidden"]),
							order = 6,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Hidden"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Hidden.Show end,
									set = function()
										TrackingBar.db.profile.Hidden.Show = not TrackingBar.db.profile.Hidden.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Hidden.Show, BS["Track Hidden"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Hidden"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Hidden"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Hidden"], v)
									end,
								},
							},
						},
						Humanoids = {
							name = BS["Track Humanoids"],
							desc = (L["Config %s Button"]):format( BS["Track Humanoids"]),
							order = 7,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Humanoids"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Humanoids.Show end,
									set = function()
										TrackingBar.db.profile.Humanoids.Show = not TrackingBar.db.profile.Humanoids.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Humanoids.Show, BS["Track Humanoids"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Humanoids"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Humanoids"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Humanoids"], v)
									end,
								},
							},
						},
						Undead = {
							name = BS["Track Undead"],
							desc = (L["Config %s Button"]):format( BS["Track Undead"]),
							order = 8,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Track Undead"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Undead.Show end,
									set = function()
										TrackingBar.db.profile.Undead.Show = not TrackingBar.db.profile.Undead.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Undead.Show, BS["Track Undead"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Track Undead"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Track Undead"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Track Undead"], v)
									end,
								},
							},
						},
						Minerals = {
							name = BS["Find Minerals"],
							desc = (L["Config %s Button"]):format( BS["Find Minerals"]),
							order = 9,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Find Minerals"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Minerals.Show end,
									set = function()
										TrackingBar.db.profile.Minerals.Show = not TrackingBar.db.profile.Minerals.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Minerals.Show, BS["Find Minerals"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Find Minerals"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Find Minerals"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Find Minerals"], v)
									end,
								},
							},
						},
						Herbs = {
							name = BS["Find Herbs"],
							desc = (L["Config %s Button"]):format( BS["Find Herbs"]),
							order = 10,
							type = 'group',
							args = {
								Show = {
									name = L["Show"],
									desc = (L["Show %s button"]):format(BS["Find Herbs"]),
									type = 'toggle',
									disabled = function() return InCombatLockdown() end,
									get = function() return TrackingBar.db.profile.Herbs.Show end,
									set = function()
										TrackingBar.db.profile.Herbs.Show = not TrackingBar.db.profile.Herbs.Show
										TrackingBar:SetButtonNum(TrackingBar.db.profile.Herbs.Show, BS["Find Herbs"])
									end
								},
								Binding = {
									name = L["Binding"],
									desc = (L["Set %s button binding key"]):format(BS["Find Herbs"]),
									type = 'text',
									validate = 'keybinding',
									disabled = function() return InCombatLockdown() end,
									get = function() return GetBindingKey("SPELL "..BS["Find Herbs"]) end,
									set = function(v)
										TrackingBar:SetBinding(BS["Find Herbs"], v)
									end,
								},
							},
						},
					},
				},
			},
		},
	}
}

function TrackingBar:OnInitialize()
	local defaults = {
		Scale = 1,
		Alpha = 1,
		Direct = "Horizontal",
		Reverse = "Normal",
		Beasts = {Show = true, Order = 1},
		Demons = {Show = true, Order = 2},
		Dragonkin = {Show = true, Order = 3},
		Elementals = {Show = true, Order = 4},
		Giants = {Show = true, Order = 5},
		Hidden = {Show = true, Order = 6},
		Humanoids = {Show = true, Order = 7},
		Undead = {Show = true, Order = 8},
		Minerals = {Show = true, Order = 9},
		Herbs = {Show = true, Order = 10},
		Number = 10,
		TrackingList = {
			[1] = BS["Track Beasts"],
			[2] = BS["Track Demons"],
			[3] = BS["Track Dragonkin"],
			[4] = BS["Track Elementals"],
			[5] = BS["Track Giants"],
			[6] = BS["Track Hidden"],
			[7] = BS["Track Humanoids"],
			[8] = BS["Track Undead"],
			[9] = BS["Find Minerals"],
			[10] = BS["Find Herbs"],
			[11] = nil,
		}
	}

	self:RegisterDB("TrackingBarDB")
	self:RegisterDefaults('profile', defaults)
	self:RegisterChatCommand('/tbar', TrackingBarOptionTable)

	TrackingBar:SetUp()
end

function TrackingBar:SetTooltip()
	if (this:GetAttribute("id")) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);
		GameTooltip:SetSpell(this:GetAttribute("id"), SpellBookFrame.bookType);
		GameTooltip:Show();
	end
end

function TrackingBar:SetButtonNum(value, track)
	if value == true then
		TrackingBar.db.profile.Number = TrackingBar.db.profile.Number  + 1
		if not TrackingBar.db.profile.TrackingList then
			TrackingBar.db.profile.TrackingList = { }
		end
		TrackingBar.db.profile.TrackingList[TrackingBar.db.profile.Number] = track
		getglobal("TrackingBarButton"..TrackingBar.db.profile.Number):Show()
	else
		TrackingBar.db.profile.Number = TrackingBar.db.profile.Number  - 1
		getglobal("TrackingBarButton"..TrackingBar.db.profile.Number + 1):Hide()
		for k, v in pairs(TrackingBar.db.profile.TrackingList) do
			if v == track then
				for i = k, 10 do
					TrackingBar.db.profile.TrackingList[i] = TrackingBar.db.profile.TrackingList[i+1]
				end
			end
		end
	end
	TrackingBar:UPDATE()
end

function TrackingBar:SetBinding(track, bind)
	local clear1, clear2 = GetBindingKey("SPELL "..track)
	if clear1 then
		SetBinding(clear1)
	end
	if clear2 then
		SetBinding(clear2)
	end
	SetBinding(bind)
	SetBindingSpell(bind, track)
	SaveBindings(GetCurrentBindingSet())
end

function TrackingBar:SetOrder(as, o)
	
end

function TrackingBar:GetSpellID(spell, rank)
	local i = 1;
	local spellID, highestRank;
	while true do
		local spellName, spellRank = GetSpellName(i, SpellBookFrame.bookType);
		if (not spellName) then
			break;
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					return i;
				end
			else
				spellID = i;
				highestRank = spellRank;
			end
		end
		i = i + 1;
		if (i > 250) then
			break;
		end
	end			
	return spellID, highestRank;
end

function TrackingBar:OnEnable()
	self:RegisterEvent("SPELLS_CHANGED", "UPDATE")
	self:RegisterEvent("PLAYER_AURAS_CHANGED", "UPDATE")
	self:RegisterEvent("SPELL_UPDATE_COOLDOWN")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
end

function TrackingBar:PLAYER_REGEN_ENABLED()
	inCombat = false
end

function TrackingBar:PLAYER_REGEN_DISABLED()
	inCombat = true
end

function TrackingBar:SetUp()
	-- This function cannot be performed in combat.
        if (InCombatLockdown() == nil) then
		if (TrackingBar.db.profile) then
			if TrackingBar.db.profile.Number > 1 then
				if (TrackingBar.db.profile.Direct == "Vertical" and TrackingBar.db.profile.Reverse == "Normal") then
						for i = 2, TrackingBar.db.profile.Number do
						local button = getglobal("TrackingBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("TOP", "TrackingBarButton"..i - 1, "BOTTOM", 0, 1);
					end
				elseif (TrackingBar.db.profile.Direct == "Vertical" and TrackingBar.db.profile.Reverse == "Reverse") then
						for i = 2, TrackingBar.db.profile.Number do
						local button = getglobal("TrackingBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("BOTTOM", "TrackingBarButton"..i - 1, "TOP", 0, 1);
					end
				elseif (TrackingBar.db.profile.Direct == "Horizontal" and TrackingBar.db.profile.Reverse == "Normal") then
						for i = 2, TrackingBar.db.profile.Number do
						local button = getglobal("TrackingBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("LEFT", "TrackingBarButton"..i - 1, "RIGHT", 1, 0);
					end
				elseif (TrackingBar.db.profile.Direct == "Horizontal" and TrackingBar.db.profile.Reverse == "Reverse") then
						for i = 2, TrackingBar.db.profile.Number do
						local button = getglobal("TrackingBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("RIGHT", "TrackingBarButton"..i - 1, "LEFT", 1, 0);
					end
				else
						for i = 2, TrackingBar.db.profile.Number do
						local button = getglobal("TrackingBarButton"..i);
						button:ClearAllPoints();
						button:SetPoint("LEFT", "TrackingBarButton"..i - 1, "RIGHT", 1, 0);
					end
				end
				if TrackingBar.db.profile.Scale then
					TrackingBarFrame:SetScale(TrackingBar.db.profile.Scale)
				else
					TrackingBarFrame:SetScale(1)
				end
				if TrackingBar.db.profile.Alpha then
					TrackingBarFrame:SetAlpha(TrackingBar.db.profile.Alpha)
				else
					TrackingBarFrame:SetAlpha(1)
				end
			end
		end
	end
end

function TrackingBar:UPDATE()
	local i, button, p, l;
	if (TrackingBar.db.profile and not inCombat) then
		i = 0;
		-- This function cannot be performed in combat.
		if (InCombatLockdown() == nil) then
			for key in pairs(TrackingBar.db.profile.TrackingList) do
				if getglobal("TrackingBarButton"..key) then
					getglobal("TrackingBarButton"..key):Hide();
				end
			end
			TrackingBar:SetUp()
			TrackingBarFrame:Show();
		end
		for key, value in pairs(TrackingBar.db.profile.TrackingList) do
			local id = TrackingBar:GetSpellID(value);
			if (id) then
				i = i + 1;
 				button = getglobal("TrackingBarButton"..i);
				-- This function cannot be performed in combat.
        			if (InCombatLockdown() == nil) then
					if button then
					button:SetAttribute("type", "spell");
					button:SetAttribute("spell", value);
					end
				end

  				local texture = GetSpellTexture(id, BOOKTYPE_SPELL);
				if (GetTrackingTexture () == texture) then
					texture = "Interface\\Icons\\Spell_Nature_WispSplode";
				end
				if button then
				getglobal("TrackingBarButton"..i.."Icon"):SetTexture(texture);
				button:SetAttribute("id",id);

				-- This function cannot be performed in combat.
				if (InCombatLockdown() == nil) then
						if ( i > TrackingBar.db.profile.Number ) then
							button:SetAlpha(0);
							button:Hide();
						else
							button:Show();
							button:SetAlpha(TrackingBar.db.profile.Alpha)
						end
					end
				end
			end
		end
		-- This function cannot be performed in combat.
		if ((i == 0) and (InCombatLockdown() == nil)) then
			TrackingBarFrame:Hide();
		end
	end
end

function TrackingBar:SPELL_UPDATE_COOLDOWN()
	for i = 1, TrackingBar.db.profile.Number do
		button = getglobal("TrackingBarButton"..i);
		if (button:GetAttribute("id")) then
			local cooldown = getglobal(button:GetName().."Cooldown");
			local start, duration, enable = GetSpellCooldown(button:GetAttribute("id"), SpellBookFrame.bookType);
			if (start > 0 and duration > 0) then
				cooldown:SetCooldown(start, duration);
			end
		end
	end
end